# 2FA

This is only a quick demo on how you could possible generate a second factor in form of a one-time-password using Python.

If you want to manage all your second factors in one place, this tool is not for you.

A working implementation that even stores the secret somewhat securely is possible in a dozen lines of code, see the version on the tag [`initial`](https://gitlab.cl.uni-heidelberg.de/moser/2fa/-/blob/initial/main.py) for details.

## Installation

```bash
python3 -m venv venv
source venv/bin/activate
pip install -r requirements.txt
```

## Enrollment

Launch a Python shell, e.g., using:

```bash
source venv/bin/activate
python3
```

Within the shell, type:

```python
from main import enroll_token
enroll_token("otpauth://totp/...")  # replace this with the URL you've gotten from the 2FA enrollment system
```

This will only store the token locally in the secret storage, without any validation whatsoever.

## Get token

```bash
source venv/bin/activate
./main.py
```

## License

This "project" is licensed under [CC0 1.0](https://creativecommons.org/publicdomain/zero/1.0/), i.e., released to the public domain. TL;DR: You can do whatever the fuck you want to with this code, but don't hold me liable if something bad happens.
